import { Format } from './Format';
import { Time } from './Time';
/**
 * Formats time into a string. The following list describes the available
 * formatting patterns:
 *
 * ### Hour
 * - H: 0-23
 * - HH: 00-23
 * - h: 12,1-12,1-11
 * - hh: 12,01-12,01-11
 * - k: 1-24
 * - kk: 01-24
 * - a: am,pm
 * - A: AM,PM
 * ### Minute
 * - m: 0-59
 * - mm: 00-59
 * ### Second
 * - s: 0-59
 * - ss: 00-59
 * ### Millisecond
 * - S: 0-9
 * - SS: 00-99
 * - SSS: 000-999
 */
export declare const TimeFormat: Format<Time>;
